Base58InputStream (Apache Commons Codec 1.22.1 API)
Description: declaration: package: org.apache.commons.codec.binary, class: Base58InputStream

Package org.apache.commons.codec.binary

# Class Base58InputStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
org.apache.commons.codec.binary.BaseNCodecInputStream<Base58,Base58InputStream,Base58InputStream.Builder>
org.apache.commons.codec.binary.Base58InputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class Base58InputStream extends BaseNCodecInputStream<Base58,Base58InputStream,Base58InputStream.Builder>
Provides Base58 decoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behavior of the Base58InputStream is to DECODE, whereas the default behavior of the Base58OutputStream is to ENCODE, but this behavior can be overridden by using a different constructor.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

You can set the decoding behavior when the input bytes contain leftover trailing bits that cannot be created by a valid encoding. These can be bits that are unused from the final character or entire characters. The default mode is lenient decoding.

- Lenient: Any trailing bits are composed into 8-bit bytes where possible. The remainder are discarded.
- Strict: The decoding will throw an `IllegalArgumentException` if trailing bits are not part of a valid encoding. Any unused bits from the final character must be zero. Impossible counts of entire final characters are not allowed.

When strict decoding is enabled it is expected that the decoded bytes will be re-encoded to a byte array that matches the original, i.e. no changes occur on the final character. This requires that the input bytes use the same padding and alphabet as the encoder.

Since:
  1.22.0
See Also:
  - `Base58`
  - The Base58 Encoding Scheme draft-msporny-base58-03

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Base58InputStream.Builder`
  Builds instances of Base58InputStream.

  ## Nested classes/interfaces inherited from class org.apache.commons.codec.binary.BaseNCodecInputStream

  `BaseNCodecInputStream.AbstracBuilder<T,C extends BaseNCodec,B extends AbstractBaseNCodecStreamBuilder<T,C,B>>`

- ## Field Summary

  ### Fields inherited from class java.io.FilterInputStream

  `in`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Base58InputStream(InputStream inputStream)`
  Constructs a Base58InputStream such that all data read is Base58-decoded from the original provided InputStream.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Base58InputStream.Builder`
  `builder()`
  Constructs a new Builder.

  ### Methods inherited from class org.apache.commons.codec.binary.BaseNCodecInputStream

  `available, isStrictDecoding, mark, markSupported, read, read, reset, skip`

  ### Methods inherited from class java.io.FilterInputStream

  `close, read`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Base58InputStream

    public Base58InputStream(InputStream inputStream)
    Constructs a Base58InputStream such that all data read is Base58-decoded from the original provided InputStream.
    Parameters:
      `inputStream` - InputStream to wrap.

- ## Method Details

  - ### builder

    public static Base58InputStream.Builder builder()
    Constructs a new Builder.
    Returns:
      A new Builder.